﻿--[[
    Author: darcey.lloyd@gmail.com

    Code Snippets:
    DTools.version();
    local DToolTestFrame = DTools.createTestFrame(200,200,"CENTER",0,0);

    TGA Export guide:
    8bit doesnt work
--]]
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local DMouse = {};
DMouse.version = "1.0.0";
DMouse.name = "DMouse Classic"
DMouse.debug = false;
DMouse.offset = 0;
DMouse.mainContainer = null;
-- Unable to hide/show frame in combat move off screen via offset instead
DMouse.mainContainerXOffset = 0;
DMouse.offsetHide = 10000;
DMouse.texturePath = "Interface\\AddOns\\DMouseClassic\\images\\";

DMouse.menu = {}
DMouse.menu.mainPage = nil;
DMouse.menu.page1 = nil;
DMouse.menu.page2 = nil;
DMouse.menu.page3 = nil;
DMouse.menu.page4 = nil;

DMouse.time = {}
DMouse.time.now = 99999999;
DMouse.time.prev = 0;
DMouse.time.updateFreq = 1000; -- Milliseconds 1000 = 1 sec

DMouse.EffectList = {};
DMouse.EffectList[1] = "Circles";
DMouse.EffectList[2] = "Target (Alpha)";
DMouse.EffectList[3] = "Fullscreen Crosshair";
DMouse.EffectList[4] = "Animated Crosshair 1";
DMouse.NoOfEffects = 4; -- LUA is so shait this is needed (or loop the table! wtf)

DMouse.modeReady = false; -- True when effect drawn and render function created

DMouse.circles = {};
DMouse.circles.frame1 = nil;
DMouse.circles.frame2 = nil;
DMouse.circles.frame3 = nil;
DMouse.circles.frame4 = nil;
DMouse.circles.scaleStep = 0.03;
DMouse.circles.scale1 = 0.2;
DMouse.circles.scale2 = 0.4;
DMouse.circles.scale3 = 0.6;
DMouse.circles.scale4 = 0.8;

DMouse.ef2 = {};
DMouse.ef2.frame1 = nil;
DMouse.ef2.frame2 = nil;
DMouse.ef2.scaleStep = 0.03;
DMouse.ef2.rotationSpeed = 10;
DMouse.ef2.frame1r = 0;
DMouse.ef2.scale2 = 0.4;

DMouse.ef3 = {};
DMouse.ef3.frame1 = nil;
DMouse.ef3.frame2 = nil;

DMouse.ef4 = {};
DMouse.ef4.f1 = nil;
DMouse.ef4.f2 = nil;
DMouse.ef4.f3 = nil;
DMouse.ef4.f4 = nil;

DMouse["AnimFunction"] = nil;
DMouse["AlignFunction"] = nil;


-- Working vars
DMouse.tx = 0;
DMouse.ty = 0;
DMouse.uiScale = UIParent:GetEffectiveScale();
DMouse.screenW = GetScreenWidth();
DMouse.screenH = GetScreenHeight();
DMouse.screenScaledW = DMouse.screenW * DMouse.uiScale;
DMouse.screenScaledH = DMouse.screenH * DMouse.uiScale;

DMouse.screenWStep = DMouse.screenW/100;
DMouse.screenHStep = DMouse.screenH/100;

DMouse.screenScaledWStep = 100 / DMouse.screenScaledW;
DMouse.screenScaledHStep = 100 / DMouse.screenScaledH;

DMouse.tx = 0;
DMouse.ty = 0;

DMouse.mainContainerSize = 64;
DMouse.innerContainerSize = 64;

DMouse.containerFrameOffsetX = 0 - (DMouse.mainContainerSize/2);
DMouse.containerFrameOffsetY = 0 - (DMouse.mainContainerSize/2);

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- Libs
-- NOTE: These libs rely on quite a lot of includes, see embeds.xml
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local addon = LibStub("AceAddon-3.0"):NewAddon(DMouse.name, "AceConsole-3.0")
local AceGUI = LibStub("AceGUI-3.0")
-- local icon = LibStub("LibDBIcon-1.0")
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.initPresistentVars = function()
    -- Presistent variables
    if ( not DMouseDB ) then
        DMouseDB = {};
    end

    if (DMouseDB["ShowWhenInCombatOnly"] == nil) then
        DMouseDB["ShowWhenInCombatOnly"] = true;
    end

    if (DMouseDB["HideWhenInVehicle"] == nil) then
        DMouseDB["HideWhenInVehicle"] = true;
    end

    if (DMouseDB["UserXOffset"] == nil) then
        DMouseDB["UserXOffset"] = 0;
    end

    if (DMouseDB["UserYOffset"] == nil) then
        DMouseDB["UserYOffset"] = 0;
    end

    if (DMouseDB["UpdateFrequency"] == nil) then
        DMouseDB["UpdateFrequency"] = 0.05; -- Milliseconds
    end

    if (DMouseDB["SelectedEffectIndex"] == nil) then
        DMouseDB["SelectedEffectIndex"] = 1;
    end

    if (DMouseDB["MainFrameOpacity"] == nil) then
        DMouseDB["MainFrameOpacity"] = 1;
    end


    -- Effect 1 options (Circles)
    if (DMouseDB["Effect1EnableFade"] == nil) then
        DMouseDB["Effect1EnableFade"] = true;
    end

    if (DMouseDB["Effect1ScaleLimit"] == nil) then
        DMouseDB["Effect1ScaleLimit"] = 1;
    end

    if (DMouseDB["Effect1FixFadeForScale"] == nil) then
        DMouseDB["Effect1FixFadeForScale"] = true;
    end

    -- Effect 2 options (Target Circle)



    -- Effect 3 options (Fullscreen Crosshair)
    if (DMouseDB["Effect3CrosshairSize"] == nil) then
        DMouseDB["Effect3CrosshairSize"] = 1;
    end

    if (DMouseDB["Effect3CrosshairR"] == nil) then
        DMouseDB["Effect3CrosshairR"] = 1;
    end

    if (DMouseDB["Effect3CrosshairG"] == nil) then
        DMouseDB["Effect3CrosshairG"] = 1;
    end

    if (DMouseDB["Effect3CrosshairB"] == nil) then
        DMouseDB["Effect3CrosshairB"] = 1;
    end

    if (DMouseDB["Effect3CrosshairA"] == nil) then
        DMouseDB["Effect3CrosshairA"] = 0.2;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.init = function()
    -- Persistent var init
    DMouse.initPresistentVars();

    -- Set main frame opacity (has to be done here DMouseDB not available on frame creation)
    DMouse.mainContainer:SetAlpha(DMouseDB["MainFrameOpacity"]);

    -- |cttrrggbb
    -- |c -- Change text colour, don't change this unless your output doesn't change colour, then change the '|' to '\124' (ie: \124ff000000)
    -- tt -- first two bits control the text transparency, from 00 (invisible) to ff (opaque).
    -- rr -- second two bits control red colour
    -- gg -- third two bits control green
    -- bb -- last two bits control blue

    -- Welcome message

    if (DMouse.debug) then
        print(" ");
        print("|cffff0000" .. "DMouse v" .. DMouse.version .. ": DEBUG MODE!" .. "|r");
        print(" ");
    else
        print(" ");
        print("|cffffff00" .. "DMouse v" .. DMouse.version .. ": Type /dm menu for options." .. "|r");
        print("|cffffcc00" .. "DMouse: Now has multiple effects to choose from, see options.");
        print("|cff00cc00" .. "DMouse: Got an idea for an effect? Contact me via curseforge.");
        print(" ");
    end

    -- Effect selection
    if (DMouseDB["SelectedEffectIndex"] == 1) then
        DMouse.setupEffect1();
    elseif (DMouseDB["SelectedEffectIndex"] == 2) then
        DMouse.setupEffect2();
    elseif (DMouseDB["SelectedEffectIndex"] == 3) then
        DMouse.setupEffect3();
    elseif (DMouseDB["SelectedEffectIndex"] == 4) then
        DMouse.setupEffect4();
    end

    -- Setup addon menu
    DMouse.setupMenu();

    -- Get scale values
    DMouse.uiScale = UIParent:GetEffectiveScale();
    -- print("DMouse scale = " .. scale);

    -- Setup slash commands
    SlashCmdList["DMouseCOMMAND"] = DMouse.slashCommandHandler;
    SLASH_DMouseCOMMAND1 = "/dm";

    -- initial state
    DMouse.mainContainer:Show();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 1
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupEffect1 = function()
    -- print("DMouse.setupEffect1()");
    local textureW = 64;
    local textureH = 64;

    -- Circles 1 to 4
    DMouse.circles.frame1 = DMouse.setupEffect1CircleFrame("cBlack.tga",textureW,textureH);
    DMouse.circles.frame2 = DMouse.setupEffect1CircleFrame("cWhite.tga",textureW,textureH);
    DMouse.circles.frame3 = DMouse.setupEffect1CircleFrame("cBlack.tga",textureW,textureH);
    DMouse.circles.frame4 = DMouse.setupEffect1CircleFrame("cWhite.tga",textureW,textureH);

    DMouse["AnimFunction"] = function()

        local alphaStep = 1 / DMouseDB["Effect1ScaleLimit"];
        local scaleLimit = DMouseDB["Effect1ScaleLimit"];


        DMouse.circles.scale1 = DMouse.circles.scale1 + DMouse.circles.scaleStep;
        if (DMouse.circles.scale1 >= scaleLimit) then
            DMouse.circles.scale1 = 0.01;
        end
        DMouse.circles.frame1:SetScale(DMouse.circles.scale1);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale1);
            else
                alpha = 1-DMouse.circles.scale1;
            end
            DMouse.circles.frame1:SetAlpha(alpha);
        else
            DMouse.circles.frame1:SetAlpha(1);
        end



        DMouse.circles.scale2 = DMouse.circles.scale2 + DMouse.circles.scaleStep;
        if (DMouse.circles.scale2 >= scaleLimit) then
            DMouse.circles.scale2 = 0.01;
        end
        DMouse.circles.frame2:SetScale(DMouse.circles.scale2);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale2);
            else
                alpha = 1-DMouse.circles.scale2;
            end
            DMouse.circles.frame2:SetAlpha(alpha);
        else
            DMouse.circles.frame2:SetAlpha(1);
        end


        DMouse.circles.scale3 = DMouse.circles.scale3 + DMouse.circles.scaleStep;
        if (DMouse.circles.scale3 >= scaleLimit) then
            DMouse.circles.scale3 = 0.01;
        end
        DMouse.circles.frame3:SetScale(DMouse.circles.scale3);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale3);
            else
                alpha = 1-DMouse.circles.scale3;
            end
            DMouse.circles.frame3:SetAlpha(alpha);
        else
            DMouse.circles.frame3:SetAlpha(1);
        end


        DMouse.circles.scale4 = DMouse.circles.scale4 + DMouse.circles.scaleStep;
        if (DMouse.circles.scale4 >= scaleLimit) then
            DMouse.circles.scale4 = 0.01;
        end
        DMouse.circles.frame4:SetScale(DMouse.circles.scale4);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale4);
            else
                alpha = 1-DMouse.circles.scale4;
            end
            DMouse.circles.frame4:SetAlpha(alpha);
        else
            DMouse.circles.frame4:SetAlpha(1);
        end



    end

    DMouse.modeReady = true;
end
-- # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupEffect1CircleFrame = function(textureName,w,h)
    local f = CreateFrame("Frame", "DMouseCircleFrame",DMouse.mainContainer)
    f:SetWidth(DMouse.innerContainerSize)
    f:SetHeight(DMouse.innerContainerSize)
    f:EnableMouse(false);

    local tex1 = f:CreateTexture(nil,"BACKGROUND")
    tex1:SetTexture("Interface\\AddOns\\DMouseClassic\\images\\"..textureName)
    tex1:SetAllPoints(f)

    f.texture = tex1
    f:SetPoint("CENTER",0,0)
    f:Show()

    return f;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 2
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupEffect2 = function()
    -- print("DMouse.setupEffect2()");

    -- Texture frames
    -- DTools.createTextureFrame(parent,texturePath,w,h)
    local f = DMouse.mainContainer;
    local path = DMouse.texturePath;
    DMouse.ef2.frame1 = DTools.createTextureFrame(f,path.."e2_part2_32b.tga",64,64);
    DMouse.ef2.frame1:SetScale(0.7);
    DMouse.ef2.frame1:SetAlpha(0.8);

    DMouse.ef2.frame2 = DTools.createTextureFrame(f,path.."cWhite.tga",64,64);

    DMouse["AnimFunction"] = function()
        DMouse.ef2.frame1.texture:SetRotation(DTools.degToRad(DMouse.ef2.frame1r))
        -- local rangeStep = 1 / 0.19
        -- local v = rangeStep * DMouseDB["UpdateFrequency"];
        -- local r = DMouse.ef2.rotationSpeed * v;
        -- print(r);
        DMouse.ef2.frame1r = DMouse.ef2.frame1r - DMouse.ef2.rotationSpeed;
        -- DMouse.ef2.frame1r:SetAlpha(0.85);

        if (DMouse.ef2.frame1r > 360) then
            DMouse.ef2.frame1r = 0;
        end

        local step = DMouse.circles.scaleStep;

        DMouse.circles.scale1 = DMouse.circles.scale1 + DMouse.circles.scaleStep;
        if (DMouse.circles.scale1 >= 1) then
            DMouse.circles.scale1 = 0.01;
        end
        DMouse.ef2.frame2:SetScale(DMouse.circles.scale1);
        DMouse.ef2.frame2:SetAlpha(1-DMouse.circles.scale1);

    end

    DMouse.modeReady = true;
end


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 3 - Fullscreen Crosshair
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupEffect3 = function()
    -- DTools.log("DMouse.setupEffect3()","FF0000");

    -- NOTE: If encapsulation in an attempt to prevent DROPDOWN Taint
    if (DTools.isInCombat() == false) then
        -- DTools.log("DMouse: DMouseSetupEffect3(): Setup","FF0000");

        local size = DMouseDB["Effect3CrosshairSize"];
        local r = DMouseDB["Effect3CrosshairR"];
        local g = DMouseDB["Effect3CrosshairG"];
        local b = DMouseDB["Effect3CrosshairB"];
        local a = DMouseDB["Effect3CrosshairA"];

        -- Texture frames
        -- DTools.createTextureFrame(parent,texturePath,w,h)
        local f = DMouse.mainContainer;

        -- horizontal line
        DMouse.ef3.frame1 = CreateFrame("Frame", "DME3Frame1", f)
        DMouse.ef3.frame1:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
        DMouse.ef3.frame1:SetWidth(6000)
        DMouse.ef3.frame1:SetHeight(size)
        DMouse.ef3.frame1:SetMovable(true);
        DMouse.ef3.frame1.texture = DMouse.ef3.frame1:CreateTexture(nil, "BACKGROUND")
        DMouse.ef3.frame1.texture:SetAllPoints(true)
        DMouse.ef3.frame1.texture:SetColorTexture(r,g,b, a)
        DMouse.ef3.frame1:ClearAllPoints(true);
        DMouse.ef3.frame1:SetPoint("BOTTOMLEFT",-3000,0);
        DMouse.ef3.frame1:EnableMouse(false);
        DMouse.ef3.frame1:SetMovable(true);

        -- vertical line
        DMouse.ef3.frame2 = CreateFrame("Frame", "DME3Frame1", f)
        DMouse.ef3.frame2:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
        DMouse.ef3.frame2:SetWidth(size)
        DMouse.ef3.frame2:SetHeight(6000)
        DMouse.ef3.frame2:SetMovable(true);
        DMouse.ef3.frame2.texture = DMouse.ef3.frame2:CreateTexture(nil, "BACKGROUND")
        DMouse.ef3.frame2.texture:SetAllPoints(true)
        DMouse.ef3.frame2.texture:SetColorTexture(r,g,b, a)
        DMouse.ef3.frame2:ClearAllPoints(true);
        DMouse.ef3.frame2:SetPoint("BOTTOMLEFT",0,-3000);
        DMouse.ef3.frame2:EnableMouse(false);
        DMouse.ef3.frame2:SetClampedToScreen(false);
        DMouse.ef3.frame2:SetMovable(true);

        -- Animation function
        DMouse["AnimFunction"] = function()

        end

        -- Animation function
        DMouse["AlignFunction"] = function()
            local uiScale, x, y = UIParent:GetEffectiveScale(), GetCursorPosition()

            -- Line Offsets based on thickness
            -- size 1 = 32,31
            -- size 5 = 30,29
            local size = DMouseDB["Effect3CrosshairSize"];
            local sizeOffset = size/2;

            -- DMouse.tx = DMouse.scrWidthStep * x;
            -- DMouse.tx = DMouse.resWidthStep * DMouse.tx;
            -- DMouse.tx = DMouse.tx - sizeOffset

            -- DMouse.ty = DMouse.scrHeightStep * y;
            -- DMouse.ty = DMouse.resHeightStep * DMouse.ty;
            -- DMouse.ty = DMouse.ty - sizeOffset;

            local mx, my = GetCursorPosition();

            DMouse.tx = DMouse.screenScaledWStep * mx; -- gives: 0 to 100 %
            DMouse.tx = DMouse.screenWStep * DMouse.tx; -- converts % to actual screenW x
            DMouse.tx = DMouse.tx - sizeOffset; -- Adjust for line thickness

            DMouse.ty = DMouse.screenScaledHStep * my; -- gives: 0 to 100 %
            DMouse.ty = DMouse.screenHStep * DMouse.ty; -- converts % to actual screenH y
            DMouse.ty = DMouse.ty - sizeOffset; -- Adjust for line thickness

            -- NOTE: To prevent taint you can't use frame hide/show in combat so we offset position by a long way
            DMouse.tx = DMouse.tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
            DMouse.ty = DMouse.ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

            DMouse.mainContainer:SetPoint("BOTTOMLEFT",DMouse.tx,DMouse.ty);
        end

        -- Flag effect is ready
        DMouse.modeReady = true;
    end
end

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 4
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupEffect4 = function()
    DTools.log("DMouse.setupEffect4()","FF0000");

    local size = DMouseDB["Effect3CrosshairSize"];
    local r = DMouseDB["Effect3CrosshairR"];
    local g = DMouseDB["Effect3CrosshairG"];
    local b = DMouseDB["Effect3CrosshairB"];
    local a = DMouseDB["Effect3CrosshairA"];

    DMouse.ef4.t = 0;
    DMouse.ef4.animDuration = 20;
    DMouse.ef4.dist = 1500;

    -- Texture frames
    -- DTools.createTextureFrame(parent,texturePath,w,h)
    local f = DMouse.mainContainer;

    -- line 1 (left to center)
	DMouse.ef4.f1 = CreateFrame("Frame", "DME4Frame1", f)
	DMouse.ef4.f1:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.f1:SetWidth(200)
	DMouse.ef4.f1:SetHeight(2)
	DMouse.ef4.f1:SetMovable(true);
	DMouse.ef4.f1.texture = DMouse.ef4.f1:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.f1.texture:SetAllPoints(true)
	DMouse.ef4.f1.texture:SetColorTexture(1,1,1, 0.5)
	DMouse.ef4.f1:ClearAllPoints(true);
	DMouse.ef4.f1:SetPoint("BOTTOMLEFT",0,0);
	DMouse.ef4.f1:EnableMouse(false);
    DMouse.ef4.f1:SetMovable(true);

    DMouse.ef4.f1.sx = 0;
    DMouse.ef4.f1.ex = 0;
    DMouse.ef4.f1.cx = 0;
    DMouse.ef4.f1.xRange = 0
    DMouse.ef4.f1.xStep = 0

    DMouse.ef4.f1.sw = 0
    DMouse.ef4.f1.ew = 0
    DMouse.ef4.f1.cw = 0
    DMouse.ef4.f1.wRange = 0
    DMouse.ef4.f1.wStep = 0

    -- line 2 (right to center)
	DMouse.ef4.f2 = CreateFrame("Frame", "DME4Frame2", f)
	DMouse.ef4.f2:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.f2:SetWidth(200)
	DMouse.ef4.f2:SetHeight(2)
	DMouse.ef4.f2:SetMovable(true);
	DMouse.ef4.f2.texture = DMouse.ef4.f2:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.f2.texture:SetAllPoints(true)
	DMouse.ef4.f2.texture:SetColorTexture(1,1,1, 0.5)
	DMouse.ef4.f2:ClearAllPoints(true);
	DMouse.ef4.f2:SetPoint("BOTTOMLEFT",0,0);
	DMouse.ef4.f2:EnableMouse(false);
    DMouse.ef4.f2:SetMovable(true);

    DMouse.ef4.f2.sx = 0;
    DMouse.ef4.f2.ex = 0;
    DMouse.ef4.f2.cx = 0;
    DMouse.ef4.f2.xRange = 0
    DMouse.ef4.f2.xStep = 0

    DMouse.ef4.f2.sw = 0
    DMouse.ef4.f2.ew = 0
    DMouse.ef4.f2.cw = 0
    DMouse.ef4.f2.wRange = 0
    DMouse.ef4.f2.wStep = 0

    -- line 3 (top to center)
	DMouse.ef4.f3 = CreateFrame("Frame", "DME4Frame3", f)
	DMouse.ef4.f3:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.f3:SetWidth(2)
	DMouse.ef4.f3:SetHeight(200)
	DMouse.ef4.f3:SetMovable(true);
	DMouse.ef4.f3.texture = DMouse.ef4.f3:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.f3.texture:SetAllPoints(true)
	DMouse.ef4.f3.texture:SetColorTexture(1,1,1, 0.5)
	DMouse.ef4.f3:ClearAllPoints(true);
	DMouse.ef4.f3:SetPoint("BOTTOMLEFT",0,0);
	DMouse.ef4.f3:EnableMouse(false);
    DMouse.ef4.f3:SetMovable(true);

    DMouse.ef4.f3.sy = 0;
    DMouse.ef4.f3.ey = 0;
    DMouse.ef4.f3.cy = 0;
    DMouse.ef4.f3.yRange = 0
    DMouse.ef4.f3.yStep = 0

    DMouse.ef4.f3.sh = 0
    DMouse.ef4.f3.eh = 0
    DMouse.ef4.f3.ch = 0
    DMouse.ef4.f3.hRange = 0
    DMouse.ef4.f3.hStep = 0

    -- line 4 (btm to center)
	DMouse.ef4.f4 = CreateFrame("Frame", "DME4Frame3", f)
	DMouse.ef4.f4:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.f4:SetWidth(2)
	DMouse.ef4.f4:SetHeight(200)
	DMouse.ef4.f4:SetMovable(true);
	DMouse.ef4.f4.texture = DMouse.ef4.f4:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.f4.texture:SetAllPoints(true)
	DMouse.ef4.f4.texture:SetColorTexture(1,1,1, 0.5)
	DMouse.ef4.f4:ClearAllPoints(true);
	DMouse.ef4.f4:SetPoint("BOTTOMLEFT",0,0);
	DMouse.ef4.f4:EnableMouse(false);
    DMouse.ef4.f4:SetMovable(true);

    DMouse.ef4.f4.sy = 0;
    DMouse.ef4.f4.ey = 0;
    DMouse.ef4.f4.cy = 0;
    DMouse.ef4.f4.yRange = 0
    DMouse.ef4.f4.yStep = 0

    DMouse.ef4.f4.sh = 0
    DMouse.ef4.f4.eh = 0
    DMouse.ef4.f4.ch = 0
    DMouse.ef4.f4.hRange = 0
    DMouse.ef4.f4.hStep = 0


    -- Animation function
    DMouse["AnimFunction"] = function()
        -- Time
        DMouse.ef4.t = DMouse.ef4.t + 1;
        if (DMouse.ef4.t > DMouse.ef4.animDuration) then
            DMouse.ef4.t = 0;
        end

        -- f1 width
        DMouse.ef4.f1.sw = 200;
        DMouse.ef4.f1.ew = 20;
        DMouse.ef4.f1.cw = DMouse.ef4.f1.sw;
        DMouse.ef4.f1.wRange = math.abs(DMouse.ef4.f1.sw) - math.abs(DMouse.ef4.f1.ew)
        DMouse.ef4.f1.wStep = DMouse.ef4.f1.wRange / DMouse.ef4.animDuration;
        DMouse.ef4.f1.cw = DMouse.ef4.f1.sw - (DMouse.ef4.t * DMouse.ef4.f1.wStep);
        DMouse.ef4.f1:SetWidth(DMouse.ef4.f1.cw);

        -- f1 x
        DMouse.ef4.f1.sx = -(DMouse.ef4.dist + DMouse.ef4.f1.cw);
        DMouse.ef4.f1.ex = -DMouse.ef4.f1.ew;
        DMouse.ef4.f1.xRange = math.abs(DMouse.ef4.f1.sx) - math.abs(DMouse.ef4.f1.ex)
        DMouse.ef4.f1.xStep = DMouse.ef4.f1.xRange / DMouse.ef4.animDuration;
        DMouse.ef4.f1.cx = DMouse.ef4.f1.sx + (DMouse.ef4.t * DMouse.ef4.f1.xStep);
        DMouse.ef4.f1:SetPoint("BOTTOMLEFT",DMouse.ef4.f1.cx,0);


        -- f2 width
        DMouse.ef4.f2:SetWidth(DMouse.ef4.f1.cw);

        -- f2 x
        DMouse.ef4.f2.sx = DMouse.ef4.dist;
        DMouse.ef4.f2.ex = 0;
        DMouse.ef4.f2.xRange = math.abs(DMouse.ef4.f2.sx) - math.abs(DMouse.ef4.f2.ex)
        DMouse.ef4.f2.xStep = DMouse.ef4.f2.xRange / DMouse.ef4.animDuration;
        DMouse.ef4.f2.cx = DMouse.ef4.f2.sx - (DMouse.ef4.t * DMouse.ef4.f2.xStep);
        DMouse.ef4.f2:SetPoint("BOTTOMLEFT",DMouse.ef4.f2.cx,0);

        -- f3 height
        DMouse.ef4.f3.sh = 200;
        DMouse.ef4.f3.eh = 20;
        DMouse.ef4.f3.ch = DMouse.ef4.f3.sh;
        DMouse.ef4.f3.hRange = math.abs(DMouse.ef4.f3.sh) - math.abs(DMouse.ef4.f3.eh)
        DMouse.ef4.f3.hStep = DMouse.ef4.f3.hRange / DMouse.ef4.animDuration;
        DMouse.ef4.f3.ch = DMouse.ef4.f3.sh - (DMouse.ef4.t * DMouse.ef4.f3.hStep);
        DMouse.ef4.f3:SetHeight(DMouse.ef4.f3.ch);

        -- f3 y
        DMouse.ef4.f3.sy = DMouse.ef4.dist;
        DMouse.ef4.f3.ey = 0;
        DMouse.ef4.f3.yRange = math.abs(DMouse.ef4.f3.sy) - math.abs(DMouse.ef4.f3.ey)
        DMouse.ef4.f3.yStep = DMouse.ef4.f3.yRange / DMouse.ef4.animDuration;
        DMouse.ef4.f3.cy = DMouse.ef4.f3.sy - (DMouse.ef4.t * DMouse.ef4.f3.yStep);
        DMouse.ef4.f3:SetPoint("BOTTOMLEFT",0,DMouse.ef4.f3.cy);

        -- f4 height
        DMouse.ef4.f4:SetHeight(DMouse.ef4.f3.ch);

        -- f4 y
        DMouse.ef4.f4.sy = -DMouse.ef4.dist;
        DMouse.ef4.f4.ey = -DMouse.ef4.f3.ch;
        DMouse.ef4.f4.yRange = math.abs(DMouse.ef4.f4.sy) - math.abs(DMouse.ef4.f4.ey)
        DMouse.ef4.f4.yStep = DMouse.ef4.f4.yRange / DMouse.ef4.animDuration;
        DMouse.ef4.f4.cy = DMouse.ef4.f4.sy + (DMouse.ef4.t * DMouse.ef4.f4.yStep);
        DMouse.ef4.f4:SetPoint("BOTTOMLEFT",0,DMouse.ef4.f4.cy);



        -- local m = "t:"..DMouse.ef4.t
        -- m = m .. "   f3.cy:" .. DMouse.ef4.f3.cy
        -- m = m .. "   f3.ch:" .. DMouse.ef4.f3.ch
        -- m = m .. "   f4.sy:" .. DMouse.ef4.f4.sy
        -- m = m .. "   f4.ey:" .. DMouse.ef4.f4.ey
        -- m = m .. "   f4.cy:" .. DMouse.ef4.f4.cy
        -- m = m .. "   f4.ch:" .. DMouse.ef4.f4.ch

        -- m = m .. "   f1.cx:" .. DMouse.ef4.f1.cx
        -- m = m .. "   f1.cw:" .. DMouse.ef4.f1.cw
        -- m = m .. "   f2.cx:" .. DMouse.ef4.f2.cx
        -- m = m .. "   f2.cw:" .. DMouse.ef4.f2.cw
        -- print(m);
    end

    -- Animation function
    DMouse["AlignFunction"] = function()
        local uiScale, x, y = UIParent:GetEffectiveScale(), GetCursorPosition()

        -- Line Offsets based on thickness
        -- size 1 = 32,31
        -- size 5 = 30,29
        local size = DMouseDB["Effect3CrosshairSize"];
        local step = 2/30;
        local sizeOffset = size/2;

        -- DMouse.tx = DMouse.scrWidthStep * x;
        -- DMouse.tx = DMouse.resWidthStep * xp;
        -- DMouse.tx = DMouse.tx - sizeOffset

        -- DMouse.ty = DMouse.scrHeightStep * y;
        -- DMouse.ty = DMouse.resHeightStep * yp;
        -- DMouse.ty = DMouse.ty - sizeOffset;

        -- DMouse.tx = DMouse.tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
        -- DMouse.ty = DMouse.ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

        -- DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);

        local mx, my = GetCursorPosition();

        DMouse.tx = DMouse.screenScaledWStep * mx; -- gives: 0 to 100 %
        DMouse.tx = DMouse.screenWStep * DMouse.tx; -- converts % to actual screenW x
        DMouse.tx = DMouse.tx - sizeOffset; -- Adjust for line thickness

        DMouse.ty = DMouse.screenScaledHStep * my; -- gives: 0 to 100 %
        DMouse.ty = DMouse.screenHStep * DMouse.ty; -- converts % to actual screenH y
        DMouse.ty = DMouse.ty - sizeOffset; -- Adjust for line thickness

        -- NOTE: To prevent taint you can't use frame hide/show in combat so we offset position by a long way
        DMouse.tx = DMouse.tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
        DMouse.ty = DMouse.ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

        DMouse.mainContainer:SetPoint("BOTTOMLEFT",DMouse.tx,DMouse.ty);
    end

    -- Flag effect is ready
    DMouse.modeReady = true;
end

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #











-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.onUpdateHandler = function(self)
    -- Check if mode has been setup and is ready for animation
    if (DMouse.modeReady == false) then
        return;
    end

    -- Handle combat only
    DMouse.mainContainerXOffset = DMouse.offsetHide;
    if (DMouseDB["ShowWhenInCombatOnly"]) then
        if (DTools.isInCombat()) then
            -- CombatOnly:1 & combat:1
            -- show
            DMouse.mainContainerXOffset = 0;
        else
            -- CombatOnly:1 & combat:0
            -- hide
            DMouse.mainContainerXOffset = DMouse.offsetHide;
        end
    else
        -- Always show
        DMouse.mainContainerXOffset = 0;
    end


    -- Handle vehicle
    if (DTools.isInVehicle() and DMouseDB["DisableWhenInVehicle"]) then
        DMouse.mainContainerXOffset = DMouse.offsetHide;
    end


    -- Align the frame with the mouse
    DMouse.alignToMouse();


    -- Check if it's time to update the animation
    DMouse.time.now = GetTime();
    local timeSinceLastUpdate = DMouse.time.now - DMouse.time.prev;
    if (timeSinceLastUpdate >= (DMouseDB["UpdateFrequency"])) then
        -- print("UPDATE: " .. DMouse.time.now);
        -- print("DTools.inCombat = " .. DTools.inCombat);
        -- print("DTools.inVehicle = " .. DTools.inVehicle);
        -- Animation function is dynamically set per each effect
        if (DMouse["AnimFunction"] ~= nil) then
            DMouse["AnimFunction"]();
        end
        DMouse.time.prev = DMouse.time.now;
    end





end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- AlignToMouse
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.alignToMouse = function(self)
    if (DMouse["AlignFunction"] ~= nil) then
        DMouse["AlignFunction"]();
    else

        local mx, my = GetCursorPosition();

        DMouse.tx = DMouse.screenScaledWStep * mx; -- gives: 0 to 100 %
        DMouse.tx = DMouse.screenWStep * DMouse.tx; -- converts % to actual screenW x
        DMouse.tx = DMouse.tx + DMouse.containerFrameOffsetX; -- compensate for container size

        DMouse.ty = DMouse.screenScaledHStep * my; -- gives: 0 to 100 %
        DMouse.ty = DMouse.screenHStep * DMouse.ty; -- converts % to actual screenH y
        DMouse.ty = DMouse.ty + DMouse.containerFrameOffsetY; -- compensate for container size

        -- NOTE: To prevent taint you can't use frame hide/show in combat so we offset position by a long way
        DMouse.tx = DMouse.tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
        DMouse.ty = DMouse.ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

        -- DO NOT DELETE GOOD FOR DEBUG
        -- local msg = "" ..
        --             "mx:" .. tostring( roundTo(mx,1) ) ..
        --             "  my:" .. tostring( roundTo(my,1) ) ..
        --             "  uiScale:" .. tostring( roundTo(DMouse.uiScale,1) ) ..
        --             "  scrW:" .. tostring( roundTo(DMouse.screenW,1) ) ..
        --             "  scrH:" .. tostring( roundTo(DMouse.screenH,1) ) ..
        --             "  tx:" .. tostring( roundTo(DMouse.tx,1) ) ..
        --             "  ty:" .. tostring( roundTo(DMouse.ty,1) )
        --             --"    tx:" .. tostring( DUtilsRoundTo(tx,1) ) .. "    ty:" .. tostring( DUtilsRoundTo(ty,1) )
        -- print( msg );

        --print( "tx:" .. tostring( DUtilsRoundTo(tx,1) ) .. "    ty:" .. tostring( DUtilsRoundTo(ty,1) ) );
        --print("----");

        --DMouse.mainContainer:ClearAllPoints();
        -- DMouse.mainContainer:SetPoint("BOTTOMLEFT",DMouse.tx,DMouse.ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",DMouse.tx,DMouse.ty);
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupMenu = function()
    -- Main page
    -- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
    DMouse.menu.mainPage = CreateFrame( "Frame", "DMouseClassicMenuPage", UIParent );
    DMouse.setupMenuMainPage();
    DMouse.setupMenuPage1();
    DMouse.setupMenuPage2();
    DMouse.setupMenuPage3();

    -- Force an initial align, prevents requires mouse to align on start
    DMouse.alignToMouse();


    -- -- local page1 = DTools.createTestFrame(200,200,"TOPLEFT",0,0); -- For visual without opening menu
    -- local page1 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    -- DTools.createText(page1,"Page 1",24,x,-10)

    -- local page2 = CreateFrame( "Frame", "DMouseMenuPage2", UIParent );
    -- DTools.createText(page2,"Page 2",24,x,-10)



    local addonMenu = DTools.createAddonMenu(
        "DMouse (Classic)",DMouseVersion,"darcey.lloyd@gmail.com",
        DMouse.menu.mainPage
    );



    addonMenu.addPage("Circles",DMouse.menu.page1);
    addonMenu.addPage("Target (Alpha)",DMouse.menu.page2);
    addonMenu.addPage("Fullscreen Crosshair",DMouse.menu.page3);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Effect 1 / Page 1 - Circles menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupMenuPage1 = function()
    local x = 10;
    local y = -10;

    DMouse.menu.page1 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    DTools.createText(DMouse.menu.page1,"DMouse - Effect 1 Options",18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


    -- Checkbox: Enable/Disable fade effect
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb1ClickHandler = function(checked)
        DMouseDB["Effect1EnableFade"]  = checked;
    end
	local cb1 = DTools.createCheckbox(
        "cb1",DMouse.menu.page1,"Enable fade effect?",
        x,y,
        DMouseDB["Effect1EnableFade"],
        cb1ClickHandler
    )
    y = y - 50; -- estimate height of item



    -- Slider: xOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
		DMouseDB["Effect1ScaleLimit"] = val;
    end
	local s1 = DTools.createSlider(
        DMouse.menu.page1,
        0.5,4,0.1,
        "Scale limit",
        DMouseDB["Effect1ScaleLimit"],
        200,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item



    -- Checkbox: Enable/Disable fix fade for scale
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb2ClickHandler = function(checked)
        DMouseDB["Effect1FixFadeForScale"]  = checked;
    end
	local cb2 = DTools.createCheckbox(
        "cb2",DMouse.menu.page1,"Correct fade effect for scale?",
        x,y,
        DMouseDB["Effect1FixFadeForScale"],
        cb2ClickHandler
    )
    y = y - 50; -- estimate height of item


end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Effect 2 / Page 2 - Target menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupMenuPage2 = function()
    local x = 10;
    local y = -10;

    DMouse.menu.page2 = CreateFrame( "Frame", "DMouseMenuPage2", UIParent );
    DTools.createText(DMouse.menu.page2,"DMouse - Effect 2 Options",18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


    -- Warning for reset button
    local msg = "";
    msg = msg .. "This is an alpha preview effect, it may be modified or removed in future updates." .. "\n"
    DTools.createText(DMouse.menu.page2,msg,12,"LEFT",x,y,1,0,0)
    y = y - 14; -- estimate height of item
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Effect 3 / Page 3 - Menu Fullscreen crosshair menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupMenuPage3 = function()
    local x = 10;
    local y = -10;
    local min,max,step = 0,1,0.1;

    DMouse.menu.page3 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    DTools.createText(DMouse.menu.page3,"DMouse - Effect 3 Options",18,"LEFT",x,y,1,1,0)
    y = y - 50; -- estimate height of item



    -- Slider: thickness
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
        DMouseDB["Effect3CrosshairSize"] = val;
        DMouse.ef3.frame1:SetWidth(6000)
        DMouse.ef3.frame1:SetHeight(val)

        DMouse.ef3.frame2:SetWidth(val)
        DMouse.ef3.frame2:SetHeight(6000)
    end
	local s1 = DTools.createSlider(
        DMouse.menu.page3,
        1,100,1,
        "Crosshair thickness",
        DMouseDB["Effect3CrosshairSize"],
        380,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item




    -- Sliders: r,g,b,a
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderRedChangeHandler = function(val)
        DMouseDB["Effect3CrosshairR"] = val;
        DMouse.effect4SetColor();
    end
    min,max,step = 0,1,0.1;
	local sR = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Red",DMouseDB["Effect3CrosshairR"],
        80,1,
        10,y,
        sliderRedChangeHandler,true
    )

    local sliderGreenChangeHandler = function(val)
        DMouseDB["Effect3CrosshairG"] = val;
        DMouse.effect4SetColor();
    end
	local sG = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Green",DMouseDB["Effect3CrosshairG"],
        80,1,
        100,y,
        sliderGreenChangeHandler,true
    )

    local sliderBlueChangeHandler = function(val)
        DMouseDB["Effect3CrosshairB"] = val;
        DMouse.effect4SetColor();
    end
	local sB = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Blue",DMouseDB["Effect3CrosshairB"],
        80,1,
        190,y,
        sliderBlueChangeHandler,true
    )

    local sliderAlphaChangeHandler = function(val)
        DMouseDB["Effect3CrosshairA"] = val;
        DMouse.effect4SetColor();
    end
	local sA = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Alpha",DMouseDB["Effect3CrosshairA"],
        80,1,
        280,y,
        sliderAlphaChangeHandler,true
    )


    y = y - 60; -- estimate height of item

end

DMouse.effect4SetColor = function()
    local r = DMouseDB["Effect3CrosshairR"];
    local g = DMouseDB["Effect3CrosshairG"];
    local b = DMouseDB["Effect3CrosshairB"];
    local a = DMouseDB["Effect3CrosshairA"];

    DMouse.ef3.frame1.texture:SetColorTexture(r,g,b,a)
    DMouse.ef3.frame2.texture:SetColorTexture(r,g,b,a)
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Main page menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.setupMenuMainPage = function()
    local x = 10;
    local y = -10;


    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(DMouse.menu.mainPage,"DMouse v" .. DMouse.version,18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


	-- Checkbox: Show in combat only
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb1ClickHandler = function(checked)
        DMouseDB["ShowWhenInCombatOnly"]  = checked;
    end
	local cb1 = DTools.createCheckbox(
        "cb1",DMouse.menu.mainPage,"Show in combat only?",
        x,y,
        DMouseDB["ShowWhenInCombatOnly"],
        cb1ClickHandler
    )
    y = y - 50; -- estimate height of item



    -- Checkbox: Hide when in vehicle?
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	-- local cb2ClickHandler = function(checked)
    --     DMouseDB["HideWhenInVehicle"]  = checked;
    -- end
	-- local cb2 = DTools.createCheckbox(
    --     "cb2",DMouse.menu.mainPage,"Hide when in vehicle?",
    --     x,y,
    --     DMouseDB["HideWhenInVehicle"],
    --     cb2ClickHandler
    -- )
    -- y = y - 40; -- estimate height of item









    -- Label for drop down
    DTools.createText(DMouse.menu.mainPage,"Effect choice:",12,"LEFT",x,y)
    y = y - 14; -- estimate height of item
    DTools.createText(DMouse.menu.mainPage,"NOTE: Each effect has its own configuration options page.",12,"LEFT",x,y,1,0.7,0)
    y = y - 14; -- estimate height of item



    -- WARNING: LUA Tables / Arrays start at index 1
    local dpSelectEffectChangeHandler = function(obj,event,v)
        -- print("dd1ChangeHandler(index:" .. index ..",value:"..value..")");
        DMouseDB["SelectedEffectIndex"] = v;
        ReloadUI();
    end

    -- ACEGUI3.0 DropDown (Bliz's causes taint)
	local dpSelectEffect = AceGUI:Create("Dropdown")
	dpSelectEffect.frame:SetParent(DMouse.menu.mainPage)
	dpSelectEffect.frame:SetFrameLevel(dpSelectEffect.frame:GetFrameLevel() + 2)
	dpSelectEffect:SetCallback("OnValueChanged", dpSelectEffectChangeHandler)
	dpSelectEffect.frame:SetPoint("TOPLEFT", x, y)
	dpSelectEffect.frame:Show()
    dpSelectEffect:SetLabel("")
    -- dpSelectEffect:SetList({
    --     ["choice1"] = "Text for Choice #1",
    --     ["choice2"] = "Text for Choice #2",
    --   })
    dpSelectEffect:SetList(DMouse.EffectList);
    dpSelectEffect:SetValue(DMouseDB["SelectedEffectIndex"]) -- choice1 is checked initialy
    y = y - 30; -- estimate height of item

    -- Warning for drop down
    DTools.createText(DMouse.menu.mainPage,"NOTE: WILL CAUSE UI RELOAD",12,"LEFT",x,y,1,0,0)
    y = y - 45; -- estimate height of item



    -- Slider: xOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
		DMouseDB["UserXOffset"] = val;
    end
	local s1 = DTools.createSlider(
        DMouse.menu.mainPage,
        -100,100,0.1,
        "X Offset",
        DMouseDB["UserXOffset"],
        200,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    -- y = y - 60; -- estimate height of item

    -- Slider: yOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s2Changehandler = function(val)
		DMouseDB["UserYOffset"] = val;
    end
	local s2 = DTools.createSlider(
        DMouse.menu.mainPage,
        -100,100,0.1,
        "Y Offset",
        DMouseDB["UserYOffset"],
        200,
        1,
        x+240,y,
        s2Changehandler,
        true
    )
    y = y - 60; -- estimate height of item




    -- Slider: Update speed
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s3Changehandler = function(val)
		DMouseDB["UpdateFrequency"] = val;
    end
	local s3 = DTools.createSlider(
        DMouse.menu.mainPage,
        0.01,0.2,0.01,
        "Update speed (MS)",
        DMouseDB["UpdateFrequency"],
        200,
        2,
        x,y,
        s3Changehandler,
        true
    )
    y = y - 60; -- estimate height of item

    -- Slider: Mainframe opacity
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s4Changehandler = function(val)
        DMouseDB["MainFrameOpacity"] = val;
        DMouse.mainContainer:SetAlpha(DMouseDB["MainFrameOpacity"]);
    end
	local s3 = DTools.createSlider(
        DMouse.menu.mainPage,
        0.01,1,0.01,
        "Global Transparency",
        DMouseDB["MainFrameOpacity"],
        200,
        2,
        x,y,
        s4Changehandler,
        true
    )
    y = y - 60; -- estimate height of item






    -- Button
    -- createButton(frame,label,width,x,y,clickHandler,fontSize);
	local btnResetClick = function()
        DMouseDB["ShowWhenInCombatOnly"] = true;
        DMouseDB["HideWhenInVehicle"] = true;
        DMouseDB["UserXOffset"] = 0;
        DMouseDB["UserYOffset"] = 0;
        DMouseDB["UpdateFrequency"] = 0.05;
        DMouseDB["SelectedEffectIndex"] = 1;

        DMouseDB["Effect1EnableFade"] = true;
        DMouseDB["Effect1ScaleLimit"] = 1;
        DMouseDB["Effect1FixFadeForScale"] = true;
        DMouseDB["Effect3CrosshairSize"] = 1;
        DMouseDB["Effect3CrosshairR"] = 1;
        DMouseDB["Effect3CrosshairG"] = 1;
        DMouseDB["Effect3CrosshairB"] = 1;
        DMouseDB["Effect3CrosshairA"] = 0.3;

        ReloadUI();
    end
    local btnReset = DTools.createButton(DMouse.menu.mainPage,"RESET",100,x,y,btnResetClick);
    y = y - 26; -- estimate height of item



    -- Warning for reset button
    DTools.createText(DMouse.menu.mainPage,"NOTE: WILL CAUSE UI RELOAD",12,"LEFT",x,y,1,0,0)
    y = y - 20; -- estimate height of item

    -- Warning for reset button
    local msg = "USAGE INFORMATION:" .. "\n"
    msg = msg .. "If you change your UI scale or screen settings you will need to reload your ui." .. "\n"
    msg = msg .. "You can do this by typing /reload" .. "\n"
    DTools.createText(DMouse.menu.mainPage,msg,12,"LEFT",x,y,1,0.6,0)
    y = y - 14; -- estimate height of item
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.slashCommandHandler = function(cmd)
    -- dmlog("DMouseSlashCommandHandler(): " .. cmd);

    -- Doing this forces sub list (pages) to be expanded
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.page1);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.page1);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.mainPage);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.mainPage);

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Main frame setup
-- Ensure this is last as certain things will not be ready
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DMouse.mainContainer = CreateFrame("Frame", "DMouse", UIParent)
DMouse.mainContainer:SetFrameStrata("BACKGROUND");
--DMouse.mainContainer:SetFrameStrata("BACKGROUND")
DMouse.mainContainer:SetWidth(DMouse.mainContainerSize)
DMouse.mainContainer:SetHeight(DMouse.mainContainerSize)
DMouse.mainContainer:SetMovable(true);
if (DMouse.debug == true) then
    DTools.setFrameBackground(DMouse.mainContainer,0,0,0,0.5);
end
--DMouse.mainContainer:SetPoint("CENTER",0,0)
DMouse.mainContainer:Show();
DMouse.mainContainer:EnableMouse(false);
DMouse.mainContainer:RegisterEvent("VARIABLES_LOADED");
DMouse.mainContainer:SetScript("OnEvent", function(self,event,addonName)
    -- print("EVENT = " .. event);
    if (event == "VARIABLES_LOADED") then
        DMouse.init();
    end
end);
DMouse.mainContainer:SetScript("OnUpdate", DMouse.onUpdateHandler );
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #